import { TestingCore } from '../testing-core.abstract';
import { TestingDescribe } from '../testing-describe.class';
import { TestingExpectation } from '../testing-expectation.class';
import { TestingIt } from '../testing-it.class';
import { TestingItToBe } from './testing-it-to-be.class';
import { TestingItToHave } from './testing-it-to-have.class';
import { TestingItToThrow } from './testing-it-to-throw.class';
import { CounterConfig } from '../../type/counter-config.type';
import { ExpectType } from '../../type';
import { ExecutableTests } from '../../interface/executable-tests.interface';
export declare class TestingItTo<Descriptions extends string = string, Expectations extends string = string> extends TestingCore<Descriptions, Expectations> {
    #private;
    get be(): TestingItToBe<string, string>;
    get have(): TestingItToHave<string, string>;
    get throw(): TestingItToThrow<string, string>;
    constructor(allowDescribe: boolean, allowIt: boolean, executable?: ExecutableTests, counter?: CounterConfig, testingDescribe?: TestingDescribe, testingIt?: TestingIt, testingExpectation?: TestingExpectation);
    contain<T>(actual: ExpectType<T>, expected: any, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
    equal<T>(actual: ExpectType<T>, expected: jasmine.Expected<typeof actual>, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
    match<T>(actual: ExpectType<T>, expected: string | RegExp, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
}
