import { TestingCore } from '../testing-core.abstract';
import { TestingDescribe } from '../testing-describe.class';
import { TestingExpectation } from '../testing-expectation.class';
import { TestingIt } from '../testing-it.class';
import { TestingItToThrow } from '../it';
import { CounterConfig, ExpectType } from '../../type';
import { ExecutableTests } from '../../interface/executable-tests.interface';
export declare class TestingToThrow<Descriptions extends string = string, Expectations extends string = string> extends TestingCore<Descriptions, Expectations> {
    protected toThrow: TestingItToThrow;
    constructor(allowDescribe?: boolean, allowIt?: boolean, executable?: ExecutableTests, counter?: CounterConfig, testingDescribe?: TestingDescribe, testingIt?: TestingIt, testingExpectation?: TestingExpectation);
    toThrowError<T extends jasmine.Func>(actual: ExpectType<T>, message?: string | RegExp, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
    toThrowMatching<T>(actual: ExpectType<T>, predicate: (thrown: any) => boolean, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
}
