import { TestingCore } from '../testing-core.abstract';
import { TestingDescribe } from '../testing-describe.class';
import { TestingExpectation } from '../testing-expectation.class';
import { TestingIt } from '../testing-it.class';
import { TestingItTo } from '../it';
import { CounterConfig, ExpectType } from '../../type';
import { ExecutableTests } from '../../interface/executable-tests.interface';
export declare class TestingTo<Descriptions extends string = string, Expectations extends string = string> extends TestingCore<Descriptions, Expectations> {
    to: TestingItTo;
    constructor(allowDescribe?: boolean, allowIt?: boolean, executable?: ExecutableTests, counter?: CounterConfig, testingDescribe?: TestingDescribe, testingIt?: TestingIt, testingExpectation?: TestingExpectation);
    toBe<T>(actual: ExpectType<T>, expected: jasmine.Expected<typeof actual>, expectation: string, expectationFailOutput?: any, execute?: boolean): this;
    toContain<T>(actual: ExpectType<T>, expected: any, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
    toEqual<T>(actual: ExpectType<T>, expected: jasmine.Expected<typeof actual>, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
    toMatch<T>(actual: ExpectType<T>, expected: string | RegExp, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
    toThrow<T>(actual: ExpectType<T>, expected?: any, expectation?: string, expectationFailOutput?: any, execute?: boolean): this;
}
